import * as mc from "@minecraft/server";

mc.world.afterEvents.itemCompleteUse.subscribe( data => {
    const item = data.itemStack;
    const player = data.source;
    const equip = player.getComponent('equippable');
    const item2 = equip.getEquipment(mc.EquipmentSlot.Mainhand);
    if (item.lockMode != "slot" && (item2 == undefined || (item.typeId != item2.typeId && item2.lockMode != "slot"))) {
    refiller(player, item, item2);
    }
});

mc.world.afterEvents.itemReleaseUse.subscribe( data => {
    const item = data.itemStack;
    const player = data.source;
    const equip = player.getComponent('equippable');
    const item2 = equip.getEquipment(mc.EquipmentSlot.Mainhand);
    if (item.lockMode != "slot" && (item2 == undefined || (item.typeId != item2.typeId && item2.lockMode != "slot"))) {
    refiller(player, item, item2);
    }
});

mc.world.afterEvents.itemUse.subscribe( data => {
    const item = data.itemStack;
    const player = data.source;
    mc.system.runTimeout(() => {
    const equip = player.getComponent('equippable');
    const item2 = equip.getEquipment(mc.EquipmentSlot.Mainhand);
    if (item.lockMode != "slot" && (item2 == undefined || (item.typeId != item2.typeId && item2.lockMode != "slot"))) {
    refiller(player, item, item2);
        }
    }, 1);
});

mc.world.afterEvents.itemUseOn.subscribe( data => {
    const item = data.itemStack;
    const player = data.source;
    mc.system.runTimeout(() => {
    const equip = player.getComponent('equippable');
    const item2 = equip.getEquipment(mc.EquipmentSlot.Mainhand);
    if (item.lockMode != "slot" && (item2 == undefined || (item.typeId != item2.typeId && item2.lockMode != "slot"))) {
    refiller(player, item, item2);
        }
    }, 1);
});

mc.world.afterEvents.playerBreakBlock.subscribe( data => {
    const item = data.itemStackBeforeBreak;
    const item2 = data.itemStackAfterBreak;
    const player = data.player;
    if (item.lockMode != "slot" && (item2 == undefined || (item.typeId != item2.typeId && item2.lockMode != "slot"))) {
    refiller(player, item, item2);
    }
});

mc.world.beforeEvents.playerInteractWithEntity.subscribe( data => {
    const item = data.itemStack;
    const player = data.player;
    mc.system.runTimeout(() => {
    const equip = player.getComponent('equippable');
    const item2 = equip.getEquipment(mc.EquipmentSlot.Mainhand);
    if (item.lockMode != "slot" && (item2 == undefined || (item.typeId != item2.typeId && item2.lockMode != "slot"))) {
    refiller(player, item, item2);
        }
    }, 1);
});

    function refiller(player, item, item2) {
    const equip = player.getComponent('equippable');
    const inv = player.getComponent("minecraft:inventory").container;
    let item3 = null;
    let item4 = null;
    const ends = [
     "_axe",
     "_hoe",
     "_pickaxe",
     "_shovel",
     "_sword"
    ];
    let same = false;
    let slot = null;
    let potion = item.getComponent('minecraft:potion');
    let potion2 = null;
    for (let i = 0; i < 36; i++) {
    item3 = inv.getItem(i);
    if (item3 && (item4 == null || same == false)) {
    if (item3.typeId == item.typeId) {
    potion2 = item3.getComponent('minecraft:potion');
    if ((potion && potion2 && potion.potionEffectType.id == potion2.potionEffectType.id) || (!potion && !potion2)) {
    item4 = item3;
    slot = i;
    same = true;
    } else {
    item4 = item3;
    slot = i;
    }} else if (slot == null) {
      for (let j = 0; j < 6; j++) {
      if (item3 && item3.typeId.endsWith(ends[j]) && item.typeId.endsWith(ends[j])) {
      item4 = item3;
      slot = i;
        }
      }}
    }}
    if (item4 != null) {
    equip.setEquipment(mc.EquipmentSlot.Mainhand, item4);
    inv.setItem(slot, item2);
    }}